'-------------------------------------------------------------------------------
' FBServer.bas - Demo server program
'
' Brief description:
' AT ALL TIMES: The Server "listens" on a non-blocking 'master' socket, so that WndProc Msgs
' can be serviced.
'
' Connection:
' A request for connection from a remote computer generates a WndProc Msg with an FD_ACCEPT event.
' A ConnPending flag is set. The sktAccept() func is called, when this flag is activated, and a
' NEW 'client' socket is created (by the system) with IDENTICAL settings to the master socket.
'
' Communications:
' This NEW Client socket (IN THE SERVER) is non-blocking, and is re-configured to ONLY have an
' FD_CLOSE event active (only way I could definitively know if/when the client disconnects!)
' This NEW 'client' socket (handle) is used in all further comms with the remote computer.
'
' The 'master' socket remains in the "listening" state, waiting for new connections.
' An array of 'client' sockets allows multiple connections to the server, if you choose.
' The server services all activity from connected clients, in whatever way you want. I have
' stuck with a simple comms protocol. Housekeeping of active client connections etc must be
' performed by the server as well.
' 
' FreeBasic code generated by RapidFRM v1.82
'-------------------------------------------------------------------------------
#INCLUDE "windows.bi"
#INCLUDE "win/commctrl.bi"
InitCommonControls()

#DEFINE __QSOCKET
#INCLUDE ONCE "win/winsock.bi"
#INCLUDE "win/RQInclude.bi"

'-------------------------------------------------------------------------------
' Some global socket data - NB Client uses 'fixed' SERVER_PORT
'-------------------------------------------------------------------------------
#DEFINE SERVER_PORT 5000                            ' Pick a number < 65535
#DEFINE MAX_CLIENTS 64

#DEFINE WHO_DAT

DIM SHARED AS integer ListenSocket                  ' Master listening socket (handle)
DIM SHARED AS integer Clients(1 TO MAX_CLIENTS)     ' Remote connection socket handles
DIM SHARED AS integer NumClients=0

'-------------------------------------------------------------------------------
' Global data from Form designer sheet
'-------------------------------------------------------------------------------
DIM SHARED AS QFORM Form1
DIM SHARED AS QFORM PTR lpForm1 = @Form1
DIM SHARED AS QLISTBOX ListBox1
DIM SHARED AS QLISTBOX PTR lpListBox1 = @ListBox1
DIM SHARED AS QBUTTON Butn1
DIM SHARED AS QBUTTON PTR lpButn1 = @Butn1
DIM SHARED AS QBUTTON Butn2
DIM SHARED AS QBUTTON PTR lpButn2 = @Butn2
DIM SHARED AS QTIMER Timer1
DIM SHARED AS QTIMER PTR lpTimer1 = @Timer1
DIM SHARED AS QSOCKET Socket1
DIM SHARED AS QSOCKET PTR lpSocket1 = @Socket1

'-------------------------------------------------------------------------------
' Forward declarations for component events 
'-------------------------------------------------------------------------------
DECLARE SUB StartServer(Sender AS QBUTTON)
DECLARE SUB DoExit(Sender AS QBUTTON)
DECLARE SUB DoTimer(Sender AS QTIMER)

'-------------------------------------------------------------------------------
' Configure components
'-------------------------------------------------------------------------------
SUB ConfigureComponents

    lpForm1->ObjIndex = 0
    lpForm1->Width = 400
    lpForm1->Height = 300
    lpForm1->Caption = "FB Server"

    lpListBox1->ObjIndex = 1
    lpListBox1->Left = 10
    lpListBox1->Top = 10
    lpListBox1->Width = 370
    lpListBox1->Height = 180

    lpButn1->ObjIndex = 2
    lpButn1->Left = 60
    lpButn1->Top = 220
    lpButn1->Caption = "Start"
    lpButn1->OnClick = CAST(ANY PTR, @StartServer)

    lpButn2->ObjIndex = 3
    lpButn2->Left = 240
    lpButn2->Top = 220
    lpButn2->Caption = "EXIT"
    lpButn2->OnClick = CAST(ANY PTR, @DoExit)

    lpTimer1->ObjIndex = 4
    lpTimer1->Interval = 250
    lpTimer1->OnTimer = CAST(ANY PTR, @DoTimer)

    lpSocket1->ObjIndex = 5
    lpSocket1->Protocol = IPPROTO_TCP

END SUB

'-------------------------------------------------------------------------------
' Create components
'-------------------------------------------------------------------------------
SUB CreateMainMenu
END SUB

SUB CreatePopupMenus
END SUB

SUB CreateComponents
DIM AS UINT StdStyle, ExtStyle=0
DIM AS string ObjCaption

    lpForm1->PreSetConfig()
    StdStyle=lpForm1->objStyle
    IF lpForm1->BorderStyle > bsDialog THEN ExtStyle=WS_EX_TOOLWINDOW

    lpForm1->Handle = CreateWindowEx(ExtStyle, "RQClass", lpForm1->Caption, StdStyle, _
                    lpForm1->Left, lpForm1->Top, lpForm1->Width, lpForm1->Height, _
                    0, 0, Application.hInstance, 0)
    Application.hMainForm = lpForm1->Handle
    lpForm1->PostConfig()

    lpListBox1->PreSetConfig()
    ObjCaption=""
    StdStyle=lpListBox1->objStyle
    IF lpListBox1->Visible THEN StdStyle OR= WS_VISIBLE
    IF lpListBox1->BorderStyle=bsNone THEN ExtStyle=0 ELSE ExtStyle=WS_EX_CLIENTEDGE

    lpListBox1->Handle=CreateWindowEx(ExtStyle,lpListBox1->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpListBox1->Left, lpListBox1->Top, lpListBox1->Width, lpListBox1->Height, _
                    lpForm1->Handle, CAST(HMENU, lpListBox1->objIndex), 0, 0)

    lpListBox1->Parent = lpForm1->Handle
    lpListBox1->PostConfig()
    EnableWindow(lpListBox1->Handle, lpListBox1->Enabled)

    lpButn1->PreSetConfig()
    ObjCaption=lpButn1->Caption
    StdStyle=lpButn1->objStyle
    IF lpButn1->Visible THEN StdStyle OR= WS_VISIBLE
    ExtStyle=0

    lpButn1->Handle=CreateWindowEx(ExtStyle,lpButn1->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpButn1->Left, lpButn1->Top, lpButn1->Width, lpButn1->Height, _
                    lpForm1->Handle, CAST(HMENU, lpButn1->objIndex), 0, 0)

    lpButn1->Parent = lpForm1->Handle
    lpButn1->PostConfig()
    EnableWindow(lpButn1->Handle, lpButn1->Enabled)

    lpButn2->PreSetConfig()
    ObjCaption=lpButn2->Caption
    StdStyle=lpButn2->objStyle
    IF lpButn2->Visible THEN StdStyle OR= WS_VISIBLE
    ExtStyle=0

    lpButn2->Handle=CreateWindowEx(ExtStyle,lpButn2->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpButn2->Left, lpButn2->Top, lpButn2->Width, lpButn2->Height, _
                    lpForm1->Handle, CAST(HMENU, lpButn2->objIndex), 0, 0)

    lpButn2->Parent = lpForm1->Handle
    lpButn2->PostConfig()
    EnableWindow(lpButn2->Handle, lpButn2->Enabled)

    lpTimer1->Parent=lpForm1->Handle
    SetTimer(lpForm1->Handle, lpTimer1->ObjIndex, lpTimer1->Interval, 0)

    lpSocket1->Parent=lpForm1->Handle

    CreateMainMenu()
    CreatePopupMenus()
END SUB

'-------------------------------------------------------------------------------
' Remove Timers on Exit
'-------------------------------------------------------------------------------
SUB KillAllTimers
    KillTimer(Application.hMainForm, SYS_TIMER_IDX)
    lpTimer1->Enabled=False
    KillTimer(lpForm1->Handle, lpTimer1->ObjIndex)
END SUB

'-------------------------------------------------------------------------------
' System timer - Display hints
'-------------------------------------------------------------------------------
SUB SysDisplayHint(Parent AS HWND, HintString AS string)
DIM AS TOOLINFO ti

    ti.cbSize=sizeof(ti)
    ti.uFlags=TTF_SUBCLASS: ti.hwnd=Parent
    ti.hinst=NULL: ti.lpszText=STRPTR(HintString)
    GetClientRect(Parent, @ti.rect)
    SendMessage(Application.hWndTTip, TTM_ADDTOOL, 0, CAST(LPARAM, @ti))	
END SUB

SUB CheckSystemTimers
STATIC AS HWND TT_LastHWND
DIM AS HWND TT_hWnd
DIM AS Point TT_pnt

    TT_pnt.X=Screen.MouseX: TT_pnt.Y=Screen.MouseY
    TT_hWnd=WindowFromPoint(TT_pnt)
    IF TT_LastHWND<>TT_hWnd THEN
        TT_LastHWND=TT_hWnd
        SELECT CASE TT_hWnd
            CASE lpForm1->Handle
                IF lpForm1->ShowHint THEN
                    SysDisplayHint(lpForm1->Handle, lpForm1->Hint)
                END IF
            CASE lpListBox1->Handle
                IF lpListBox1->ShowHint THEN
                    SysDisplayHint(lpListBox1->Handle, lpListBox1->Hint)
                END IF
            CASE lpButn1->Handle
                IF lpButn1->ShowHint THEN
                    SysDisplayHint(lpButn1->Handle, lpButn1->Hint)
                END IF
            CASE lpButn2->Handle
                IF lpButn2->ShowHint THEN
                    SysDisplayHint(lpButn2->Handle, lpButn2->Hint)
                END IF
        END SELECT
    END IF
END SUB

'-------------------------------------------------------------------------------
' Start of Main WndProc code
'-------------------------------------------------------------------------------

SUB CheckWmTimers(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
    SELECT CASE wParam
        CASE App_Timer.ObjIndex:  CheckSystemTimers
        CASE lpTimer1->ObjIndex
            IF (lpTimer1->Enabled) AND (lpTimer1->OnTimer>0) THEN
                lpTimer1->OnTimer(lpTimer1)
            END IF
    END SELECT
END SUB

SUB CheckWmCommandMsg(wParam AS WPARAM, lParam AS LPARAM)
    SELECT CASE LOWORD(wParam)
        CASE lpListBox1->ObjIndex
            IF HIWORD(wParam)=LBN_SELCHANGE THEN
                IF lpListBox1->OnClick>0 THEN lpListBox1->OnClick(lpListBox1)
            END IF
            IF HIWORD(wParam)=LBN_DBLCLK THEN
                IF lpListBox1->OnDblClick>0 THEN lpListBox1->OnDblClick(lpListBox1)
            END IF
        CASE lpButn1->ObjIndex
            IF lpButn1->OnClick>0 THEN lpButn1->OnClick(lpButn1)
        CASE lpButn2->ObjIndex
            IF lpButn2->OnClick>0 THEN lpButn2->OnClick(lpButn2)
    END SELECT
END SUB

SUB CheckWmNotifyMsg(wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmPaintMsg(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
    IF lpForm1->OnPaint>0 THEN lpForm1->OnPaint(lpForm1)
END SUB

FUNCTION CheckBtnColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
' Only for OwnerDraw buttons
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

FUNCTION CheckStaticColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

FUNCTION CheckEditColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

FUNCTION CheckListBoxColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
    SELECT CASE lParam
        CASE lpListBox1->Handle
            DIM AS HDC hDC=CAST(HDC, wParam)
            DIM AS HGDIOBJ Original=SelectObject(hDC, GetStockObject(DC_BRUSH))
            hBrush=CreateSolidBrush(CAST(COLORREF, lpListBox1->Color))
            SetBkMode(hDC, 1)                          ' Transparent
            SetTextColor(hDC, CAST(COLORREF,lpListBox1->Font.color))
    END SELECT
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

SUB CheckWmObjScroll(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckSocketEvent(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
' Server: Only ONE message of interest on the server master socket - FD_ACCEPT
' Client: Only ONE message of interest FD_CLOSE, remainder of messages optional
' NB The wParam is the socket descriptor (handle)
    IF HIWORD(lParam)=0 THEN
        SELECT CASE lParam
            CASE FD_ACCEPT
                lpSocket1->ConnPending=True                ' Remote connection request
            CASE FD_CONNECT                                '|
            CASE FD_READ                                   '| Client socket asynch mode,...
            CASE FD_WRITE                                  '| ...add your dispatch code here
            CASE FD_CLOSE                                  '|
                lpSocket1->DiscPending=wParam              ' Remote disconnect notification
        END SELECT
    ELSE
        lpSocket1->MySocket=WSAGetLastError()
    END IF
END SUB

' Hook into the Popup menus for all of your components here
SUB CheckWmContextMenu(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmHitTest(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmDrawItem(wParam AS WPARAM, lParam AS LPARAM)
END SUB

FUNCTION MainWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
STATIC AS integer Sizing
    
    SELECT CASE wMsg
        CASE WM_CREATE
            Sizing=False

        CASE WM_COMMAND
            IF lParam<>0 THEN
                CheckWmCommandMsg(wParam, lParam)
            ELSE
                ' IF HIWORD(wParam)=0 THEN
                '     Menu message code goes here.....
                ' ELSE
                '     Accelerator message code goes here...
                ' END IF
            END IF

        CASE WM_NOTIFY
            CheckWmNotifyMsg(wParam, lParam)

        CASE WM_PAINT
            CheckWmPaintMsg(hWnd, wMsg, wParam, lParam)

        CASE WM_TIMER
            CheckWmTimers(hWnd, wMsg, wParam, lParam)

        CASE WM_NCHITTEST
            CheckWmHitTest(hWnd, wMsg, wParam, lParam)

        CASE WM_HSCROLL, WM_VSCROLL
            IF lParam<>0 THEN CheckWmObjScroll(hWnd, wMsg, wParam, lParam)

        CASE WM_CTLCOLORBTN
            RETURN CheckBtnColor(wParam, lParam)

        CASE WM_CTLCOLOREDIT
            RETURN CheckEditColor(wParam, lParam)

        CASE WM_CTLCOLORSTATIC
            RETURN CheckStaticColor(wParam, lParam)

        CASE WM_CTLCOLORLISTBOX
            RETURN CheckListBoxColor(wParam, lParam)

        CASE WM_DRAWITEM
            CheckWmDrawItem(wParam, lParam)

        CASE WM_CONTEXTMENU
            CheckWmContextMenu(hWnd, wMsg, wParam, lParam)

        CASE WM_SOCK_NOTIFY
            CheckSocketEvent(hWnd, wMsg, wParam, lParam)

        CASE WM_MOUSEMOVE
            IF lpForm1->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpForm1->hCursor)
            END IF
            IF lpForm1->OnMouseMove>0 THEN
                lpForm1->OnMouseMove(LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_LBUTTONDBLCLK
            IF lpForm1->OnClick>0 THEN lpForm1->OnClick(lpForm1)

        CASE WM_LBUTTONDOWN
            IF lpForm1->OnMouseDown>0 THEN
                lpForm1->OnMouseDown(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_LBUTTONUP
            IF lpForm1->OnMouseUp>0 THEN
                lpForm1->OnMouseUp(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF
            IF lpForm1->OnClick>0 THEN lpForm1->OnClick(lpForm1)

        CASE WM_RBUTTONDOWN
            IF lpForm1->OnMouseDown>0 THEN
                lpForm1->OnMouseDown(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_RBUTTONUP
            IF lpForm1->OnMouseUp>0 THEN
                lpForm1->OnMouseUp(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_KEYDOWN
            IF lpForm1->OnKeyDown>0 THEN lpForm1->OnKeyDown(LOWORD(wParam), 0, lpForm1)

        CASE WM_KEYUP
            IF lpForm1->OnKeyUp>0 THEN lpForm1->OnKeyUp(LOWORD(wParam), 0, lpForm1)

        CASE WM_CHAR
            IF lpForm1->OnKeyPress>0 THEN lpForm1->OnKeyPress(LOBYTE(wParam), lpForm1)

        CASE WM_SYSCOMMAND
            IF (wParam AND &hfff0) = SC_CLOSE THEN
                DIM AS integer Action=1                                      ' Default Action is quit
                IF lpForm1->OnClose>0 THEN lpForm1->OnClose(Action, lpForm1) ' Action passed by reference so
                IF Action=0 THEN RETURN 0                                    ' user can change default action
            END IF

        CASE WM_ENTERSIZEMOVE
            Sizing=True

        CASE WM_EXITSIZEMOVE
            lpForm1->FormReSize()
            Sizing=False
            IF lpForm1->OnResize>0 THEN
                lpForm1->OnResize(lpForm1)
                InvalidateRect(hWnd, NULL, True)
                RETURN 0
            END IF

        CASE WM_SIZE
            IF Sizing THEN RETURN 0
            IF (wParam=SIZE_MAXIMIZED) OR (wParam=SIZE_RESTORED) THEN
                lpForm1->FormReSize()
                IF lpForm1->OnResize>0 THEN
                    lpForm1->OnResize(lpForm1)
                    RETURN 0
                END IF
            END IF

        CASE WM_CLOSE

        CASE WM_DESTROY
            KillAllTimers()
            PostQuitMessage(0)

    END SELECT

    RETURN DefWindowProc(hWnd, wMsg, wParam, lParam)
END FUNCTION

'-------------------------------------------------------------------------------
' Create new window class for project
'-------------------------------------------------------------------------------
FUNCTION CreateWindClass(hInst AS HINSTANCE) AS integer
DIM AS integer Result
DIM AS WNDCLASSEX wc

WITH wc
    .cbSize = SizeOf(WNDCLASSEX)
    .style = CS_HREDRAW OR CS_VREDRAW
    .lpfnWndProc = @MainWndProc
    .hInstance = hInst
    .hIcon = LoadIcon(0, IDI_APPLICATION)
    .hCursor = LoadCursor(0, IDC_ARROW)
    .hbrBackground = GetSysColorBrush(COLOR_BTNFACE)
    .lpszClassName = @"RQClass"
    .hIconSm = .hIcon
END WITH

    Result = RegisterClassEx(@wc)
    IF Result = 0 THEN ShowMessage("Register class error")
    RETURN Result
END FUNCTION

'-------------------------------------------------------------------------------
' Main startup code
'-------------------------------------------------------------------------------
FUNCTION WinMain(hInst AS HINSTANCE, hPrevInstance AS HINSTANCE, _
                            szCmdLine AS string, iCmdShow AS integer) AS integer
DIM AS integer Result=0

    IF CreateWindClass(hInst) = 0 THEN RETURN 0

    ConfigureComponents()
    CreateComponents()
    InitSystemTimers(lpForm1->Handle)
    HookTheMouse()

    lpForm1->Center                         ' You may wish to delete this line

    IF lpForm1->OnShow>0 THEN lpForm1->OnShow(lpForm1)

    Result = lpForm1->ShowModal             ' Show form & call default message handler

    ' You may want to change the above line to lpForm1->Show, and then provide
    ' your own function that, amongst other things, handles all window messages.

    UnHookTheMouse()

    RETURN Result
END FUNCTION

'-------------------------------------------------------------------------------
' *** MAIN ENTRY POINT ***
'-------------------------------------------------------------------------------
END WinMain(Application.hInstance, NULL, Command(0), SW_NORMAL)


'-------------------------------------------------------------------------------
' Code for the component events
'-------------------------------------------------------------------------------
' Called when any client socket disconnects
SUB TidyClientSocketList
DIM AS integer j=0
    FOR i AS integer = 1 TO NumClients
        IF Clients(i)=0 THEN
            lpListBox1->AddItems("Removing client #"+STR(i))
            lpListBox1->TopIndex = lpListBox1->TopIndex+1
            j += 1
        END IF
        IF j>0 THEN Clients(i)=Clients(i+j)
    NEXT i
    IF j>0 THEN NumClients -= j
END SUB

#IFDEF WHO_DAT
FUNCTION GetPeerIP(Skt AS integer) AS string
DIM arg AS long, res AS long
DIM buf(0 TO 15) AS BYTE
DIM AS string tstr

    arg=16
    res=getpeername(Skt, CAST(sockaddr PTR, @buf(0)), @arg)
    IF res<0 OR arg<1 THEN
        RETURN "<unknown>"
    ELSE
        tstr=""
        FOR i AS integer = 4 TO 7
            res=buf(i)
            IF res<0 THEN res=res AND &Hff
            tstr=tstr & res & "."
        NEXT i
        RETURN LEFT(tstr, LEN(tstr)-1)
    END IF
END FUNCTION
#ENDIF

SUB StartServer(Sender AS QBUTTON)
    lpSocket1->Parent=Form1.Handle
    ListenSocket=lpSocket1->sktOpen(SERVER_PORT)                        ' Sets the server into listening mode
    IF ListenSocket=0 THEN
        ShowMessage("ERROR "+STR(lpSocket1->MySocket)+": opening server master socket")
        Application.Terminate
    END IF
    lpListBox1->AddItems("Server started on "+lpSocket1->GetHostName()+" ["+lpSocket1->GetHostIP()+"]")
    lpListBox1->TopIndex = lpListBox1->TopIndex+1
    Sender.Enabled=False
END SUB

SUB DoTimer(Sender AS QTIMER)
DIM AS integer Sock, Changes=False
DIM AS string buf

    ' First check for any NEW connections
    IF lpSocket1->ConnectionReady(ListenSocket)>0 THEN
        Sock=lpSocket1->sktAccept(ListenSocket)
        IF Sock=0 THEN
            lpListBox1->AddItems("ERROR "+STR(lpSocket1->MySocket)+": Accept() connection failed")
            lpListBox1->TopIndex = lpListBox1->TopIndex+1
        ELSE
            buf="Welcome user #"+STR(NumClients+1)
#IFDEF WHO_DAT
            buf = buf + " ["+GetPeerIP(Sock)+"]"                        ' Add client IP address
#ENDIF
            IF lpSocket1->WriteLine(Sock, buf)<0 THEN                   ' Send welcome message
                lpListBox1->AddItems("Client failed to connect!")
                lpListBox1->TopIndex = lpListBox1->TopIndex+1
                lpSocket1->sktClose(Sock)
            ELSE
                NumClients += 1
                Clients(NumClients)=Sock
                lpListBox1->AddItems("Connected to client #"+STR(NumClients)+" ["+lpSocket1->ReqPeerName(Sock)+"]")
                lpListBox1->TopIndex = lpListBox1->TopIndex+1
            END IF
        END IF
    END IF
    ' Now check each connected client for I/C traffic or disconnection
    FOR i AS integer = 1 TO NumClients
        Sock=Clients(i)
        IF lpSocket1->DiscPending=Sock THEN
            lpSocket1->DiscPending=0
            lpListBox1->AddItems("Client #"+STR(i)+"  disconnected!")
            lpListBox1->TopIndex = lpListBox1->TopIndex+1
            lpSocket1->sktClose(Sock)
            Clients(i)=0
            Changes=True
        ELSE
            IF lpSocket1->IsClientReady(ListenSocket, Sock) THEN        ' I/C traffic?
                buf=lpSocket1->ReadLine(Sock)                           ' Returns ONLY on NewLine char or ERROR!!
                IF lpSocket1->MySocket<>0 THEN                          ' Error?
                    lpListBox1->AddItems("ERROR "+STR(lpSocket1->MySocket)+": ReadLine() - Client #"+STR(i))
                    lpListBox1->TopIndex = lpListBox1->TopIndex+1
                    lpSocket1->sktClose(Sock)
                    Clients(i)=0
                    Changes=True
                ELSE
                    buf="From #"+STR(i)+": "+LEFT(buf, LEN(buf)-1)      ' Rcved text message (minus NewLine)
                    lpListBox1->AddItems(buf)
                    lpListBox1->TopIndex = lpListBox1->TopIndex+1
                    FOR j AS integer = 1 TO NumClients                  ' Broadcast the message to ALL clients
                        Sock=Clients(j)
                        IF Sock THEN
                            IF lpSocket1->WriteLine(Sock, buf)<0 THEN
                                lpSocket1->sktClose(Sock)
                                Clients(j)=0
                                Changes=True
                            END IF
                        END IF
                    NEXT j
                END IF
            END IF
        END IF
    NEXT i
    IF Changes THEN TidyClientSocketList
END SUB

SUB DoExit(Sender AS QBUTTON)
DIM AS integer Sock
    FOR i AS integer = 1 TO NumClients
        Sock=Clients(i)
        IF Sock > 0 THEN lpSocket1->sktClose(Sock)
    NEXT i
    lpSocket1->sktClose(ListenSocket)
    Application.Terminate
END SUB
