'-------------------------------------------------------------------------------
' QRichEdit component demo
' Manually added a popup menu to the QRichEdit component 5 Sections of code
' marked with #POPUP# comment.
' Demo EyeCandy text from Jacques Philippe plus some extras thrown in.
'
' FreeBasic code generated by RapidFRM v1.80
'-------------------------------------------------------------------------------
#INCLUDE "windows.bi"
#INCLUDE "win/commctrl.bi"
InitCommonControls()

#DEFINE __QRICHEDIT
#INCLUDE ONCE "win/richedit.bi"
DyLibLoad("Riched32.dll")

#INCLUDE "win/RQInclude.bi"

'-------------------------------------------------------------------------------
' #POPUP# Global data for RichEdit (plus some extras)
'-------------------------------------------------------------------------------
DIM SHARED AS CHARFORMAT CharFormat
DIM SHARED AS string FontNames(0 To 5)

' Popup menu indices (just a series of values, mine = 100 -> 106)
ENUM RED_POPUP: TEXT_SEL_ALL=100, TEXT_COPY, TEXT_CUT, TEXT_PASTE, FILE_LOAD, FILE_SAVE, TEXT_COLOR: END ENUM

DECLARE SUB PopMenuSelect(Idx AS integer, Sender AS QRICHEDIT)

'-------------------------------------------------------------------------------
' Global data from Form designer sheet
'-------------------------------------------------------------------------------
DIM SHARED AS QFORM Form1
DIM SHARED AS QFORM PTR lpForm1 = @Form1
DIM SHARED AS QRICHEDIT RichEd1
DIM SHARED AS QRICHEDIT PTR lpRichEd1 = @RichEd1
DIM SHARED AS QBUTTON Butn1
DIM SHARED AS QBUTTON PTR lpButn1 = @Butn1
DIM SHARED AS QBUTTON Butn2
DIM SHARED AS QBUTTON PTR lpButn2 = @Butn2

'-------------------------------------------------------------------------------
' Forward declarations for component events 
'-------------------------------------------------------------------------------
DECLARE SUB Initialise(Sender AS QFORM)
DECLARE SUB RandText(Sender AS QBUTTON)
DECLARE SUB Done(Sender AS QBUTTON)

'-------------------------------------------------------------------------------
' Configure components
'-------------------------------------------------------------------------------
SUB ConfigureComponents

    lpForm1->ObjIndex = 0
    lpForm1->Width = 700
    lpForm1->Height = 500
    lpForm1->Caption = "QRichEdit with Popup menu"
    lpForm1->OnShow = CAST(ANY PTR, @Initialise)

    lpRichEd1->ObjIndex = 1
    lpRichEd1->Left = 10
    lpRichEd1->Top = 10
    lpRichEd1->Width = 670
    lpRichEd1->Height = 420
'    lpRichEd1->ReadOnly = True
    lpRichEd1->Font.Size = 10                                           ' Plaintext font size
    lpRichEd1->HideScrollBars=False
    lpRichEd1->ScrollBars=ssBoth
    ' #POPUP# 
    lpRichEd1->OnPopup = CAST(ANY PTR, @PopMenuSelect)

    lpButn1->ObjIndex = 2
    lpButn1->Left = 100
    lpButn1->Top = 440
    lpButn1->Caption = "Random"
    lpButn1->OnClick = CAST(ANY PTR, @RandText)

    lpButn2->ObjIndex = 3
    lpButn2->Left = 500
    lpButn2->Top = 440
    lpButn2->Caption = "EXIT"
    lpButn2->OnClick = CAST(ANY PTR, @Done)
END SUB

'-------------------------------------------------------------------------------
' Create components
'-------------------------------------------------------------------------------
SUB CreateMainMenu()
END SUB

' #POPUP#
SUB CreatePopupMenus()
    lpRichEd1->PopupMenu=CreatePopupMenu()                                      ' blank menu
    AppendMenu(lpRichEd1->PopupMenu, 0, TEXT_SEL_ALL, "Select All")
    AppendMenu(lpRichEd1->PopupMenu, 0, 0, 0)                                   ' separator
    AppendMenu(lpRichEd1->PopupMenu, 0, TEXT_COPY, "Copy")
    AppendMenu(lpRichEd1->PopupMenu, 0, TEXT_CUT, "Cut")
    AppendMenu(lpRichEd1->PopupMenu, 0, TEXT_PASTE, "Paste")
    AppendMenu(lpRichEd1->PopupMenu, 0, 0, 0)                                   ' separator
    AppendMenu(lpRichEd1->PopupMenu, 0, FILE_LOAD, "Load from file")
    AppendMenu(lpRichEd1->PopupMenu, 0, FILE_SAVE, "Save to file")
    AppendMenu(lpRichEd1->PopupMenu, 0, 0, 0)                                   ' separator
    AppendMenu(lpRichEd1->PopupMenu, 0, TEXT_COLOR, "Color text")
END SUB

SUB CreateComponents
DIM AS UINT StdStyle, ExtStyle
DIM AS string ObjCaption

    lpForm1->Parent = 0
    lpForm1->Handle = CreateWindowEx(0, "RQClass", lpForm1->Caption, _
                    WS_OVERLAPPEDWINDOW, _
                    lpForm1->Left, lpForm1->Top, lpForm1->Width, lpForm1->Height, _
                    0, 0, Application.hInstance, 0)
    Application.hMainForm = lpForm1->Handle
    lpForm1->PostConfig()

    lpRichEd1->PreSetConfig()
    ObjCaption=""
    StdStyle=lpRichEd1->objStyle
    IF lpRichEd1->Visible THEN StdStyle OR= WS_VISIBLE
    IF lpRichEd1->BorderStyle=bsNone THEN ExtStyle=0 ELSE ExtStyle=WS_EX_CLIENTEDGE

    lpRichEd1->Handle=CreateWindowEx(ExtStyle,lpRichEd1->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpRichEd1->Left, lpRichEd1->Top, lpRichEd1->Width, lpRichEd1->Height, _
                    lpForm1->Handle, CAST(HMENU, lpRichEd1->objIndex), 0, 0)

    lpRichEd1->Parent = lpForm1->Handle
    lpRichEd1->PostConfig()
    EnableWindow(lpRichEd1->Handle, lpRichEd1->Enabled)

    lpButn1->PreSetConfig()
    ObjCaption=lpButn1->Caption
    StdStyle=lpButn1->objStyle
    IF lpButn1->Visible THEN StdStyle OR= WS_VISIBLE
    ExtStyle=0

    lpButn1->Handle=CreateWindowEx(ExtStyle,lpButn1->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpButn1->Left, lpButn1->Top, lpButn1->Width, lpButn1->Height, _
                    lpForm1->Handle, CAST(HMENU, lpButn1->objIndex), 0, 0)

    lpButn1->Parent = lpForm1->Handle
    lpButn1->PostConfig()
    EnableWindow(lpButn1->Handle, lpButn1->Enabled)

    lpButn2->PreSetConfig()
    ObjCaption=lpButn2->Caption
    StdStyle=lpButn2->objStyle
    IF lpButn2->Visible THEN StdStyle OR= WS_VISIBLE
    ExtStyle=0

    lpButn2->Handle=CreateWindowEx(ExtStyle,lpButn2->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpButn2->Left, lpButn2->Top, lpButn2->Width, lpButn2->Height, _
                    lpForm1->Handle, CAST(HMENU, lpButn2->objIndex), 0, 0)

    lpButn2->Parent = lpForm1->Handle
    lpButn2->PostConfig()
    EnableWindow(lpButn2->Handle, lpButn2->Enabled)

    CreateMainMenu()
    CreatePopupMenus()

END SUB

'-------------------------------------------------------------------------------
' Remove Timers on Exit
'-------------------------------------------------------------------------------
SUB KillAllTimers
    KillTimer(Application.hMainForm, SYS_TIMER_IDX)
END SUB

'-------------------------------------------------------------------------------
' System timer - Display hints
'-------------------------------------------------------------------------------
SUB SysDisplayHint(Parent AS HWND, HintString AS string)
DIM AS TOOLINFO ti

    ti.cbSize=sizeof(ti)
    ti.uFlags=TTF_SUBCLASS: ti.hwnd=Parent
    ti.hinst=NULL: ti.lpszText=STRPTR(HintString)
    GetClientRect(Parent, @ti.rect)
    SendMessage(Application.hWndTTip, TTM_ADDTOOL, 0, CAST(LPARAM, @ti))	
END SUB

SUB CheckSystemTimers
STATIC AS HWND TT_LastHWND
DIM AS HWND TT_hWnd
DIM AS Point TT_pnt

    TT_pnt.X=Screen.MouseX: TT_pnt.Y=Screen.MouseY
    TT_hWnd=WindowFromPoint(TT_pnt)
    IF TT_LastHWND<>TT_hWnd THEN
        TT_LastHWND=TT_hWnd
        SELECT CASE TT_hWnd
            CASE lpForm1->Handle
                IF lpForm1->ShowHint THEN
                    SysDisplayHint(lpForm1->Handle, lpForm1->Hint)
                END IF
            CASE lpRichEd1->Handle
                IF lpRichEd1->ShowHint THEN
                    SysDisplayHint(lpRichEd1->Handle, lpRichEd1->Hint)
                END IF
            CASE lpButn1->Handle
                IF lpButn1->ShowHint THEN
                    SysDisplayHint(lpButn1->Handle, lpButn1->Hint)
                END IF
            CASE lpButn2->Handle
                IF lpButn2->ShowHint THEN
                    SysDisplayHint(lpButn2->Handle, lpButn2->Hint)
                END IF
        END SELECT
    END IF
END SUB

'-------------------------------------------------------------------------------
' Start of Main WndProc code
'-------------------------------------------------------------------------------
SUB CheckWmCommandMsg(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
    SELECT CASE LOWORD(wParam)
        CASE lpRichEd1->ObjIndex
            IF lpRichEd1->OnChange>0 THEN lpRichEd1->OnChange(lpRichEd1)
        CASE lpButn1->ObjIndex
            IF lpButn1->OnClick>0 THEN lpButn1->OnClick(lpButn1)
        CASE lpButn2->ObjIndex
            IF lpButn2->OnClick>0 THEN lpButn2->OnClick(lpButn2)
    END SELECT
END SUB

SUB CheckWmPaintMsg(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
    IF lpForm1->OnPaint>0 THEN lpForm1->OnPaint(lpForm1)
END SUB

SUB CheckWmTimers(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
    SELECT CASE wParam
        CASE App_Timer.ObjIndex:  CheckSystemTimers
    END SELECT
END SUB

SUB CheckWmNotifyMsg(wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmHitTest(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmObjScroll(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

FUNCTION CheckEditColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

FUNCTION CheckBtnColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
DIM AS HDC hDC=CAST(HDC, wParam)
DIM AS HWND Handle=CAST(HWND, lParam)

    SELECT CASE Handle
        CASE lpButn1->Handle
            SetBKMode(hDC, 1)
            SetTextColor(hDC, CAST(COLORREF, lpButn1->Font.Color))
            hBrush=CreateSolidBrush(CAST(COLORREF, lpButn1->Color))
        CASE lpButn2->Handle
            SetBKMode(hDC, 1)
            SetTextColor(hDC, CAST(COLORREF, lpButn2->Font.Color))
            hBrush=CreateSolidBrush(CAST(COLORREF, lpButn2->Color))
    END SELECT
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

FUNCTION CheckStaticColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

FUNCTION CheckColorListBox(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
    RETURN 0
END FUNCTION

SUB CheckWmDrawItem(wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmContextMenu(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
' #POPUP#
    SELECT CASE wParam
        CASE lpRichEd1->Handle
            IF lpRichEd1->OnPopup>0 THEN
                DIM AS UINT flags=TPM_RETURNCMD OR TPM_RIGHTBUTTON OR TPM_NOANIMATION
                DIM AS integer Idx
                Idx=TrackPopupMenuEx(lpRichEd1->PopupMenu, flags, LOWORD(lParam), _
                                                        HIWORD(lParam), lpRichEd1->Handle, 0)
                lpRichEd1->OnPopup(Idx, lpRichEd1)
            END IF
    END SELECT
END SUB

SUB CheckSocketEvent(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

FUNCTION MainWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
STATIC AS integer Sizing

    SELECT CASE wMsg
        CASE WM_CREATE
            Sizing=False

        CASE WM_COMMAND
            IF lParam<>0 THEN
                CheckWmCommandMsg(hWnd, wMsg, wParam, lParam)
            ELSE
                ' IF HIWORD(wParam)=0 THEN
                '     Menu message code goes here.....
                ' ELSE
                '     Accelerator message code goes here...
                ' END IF
            END IF

        CASE WM_NOTIFY
            CheckWmNotifyMsg(wParam, lParam)

        CASE WM_PAINT
            CheckWmPaintMsg(hWnd, wMsg, wParam, lParam)

        CASE WM_TIMER
            CheckWmTimers(hWnd, wMsg, wParam, lParam)

        CASE WM_NCHITTEST
            CheckWmHitTest(hWnd, wMsg, wParam, lParam)

        CASE WM_HSCROLL, WM_VSCROLL
            IF lParam<>0 THEN CheckWmObjScroll(hWnd, wMsg, wParam, lParam)

        CASE WM_CTLCOLORBTN
            RETURN CheckBtnColor(wParam, lParam)

        CASE WM_CTLCOLOREDIT
            RETURN CheckEditColor(wParam, lParam)

        CASE WM_CTLCOLORSTATIC
            RETURN CheckStaticColor(wParam, lParam)

        CASE WM_CTLCOLORLISTBOX
            RETURN CheckColorListBox(wParam, lParam)

        CASE WM_DRAWITEM
            CheckWmDrawItem(wParam, lParam)

        CASE WM_CONTEXTMENU
            CheckWmContextMenu(hWnd, wMsg, wParam, lParam)

        CASE WM_SOCK_NOTIFY
            CheckSocketEvent(hWnd, wMsg, wParam, lParam)

        CASE WM_MOUSEMOVE
            IF lpForm1->OnMouseMove>0 THEN lpForm1->OnMouseMove(LOWORD(lParam), _
                                                            HIWORD(lParam), 0, lpForm1)
        CASE WM_LBUTTONDBLCLK
            IF lpForm1->OnClick>0 THEN lpForm1->OnClick(lpForm1)

        CASE WM_LBUTTONDOWN
            IF lpForm1->OnMouseDown>0 THEN
                lpForm1->OnMouseDown(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_LBUTTONUP
            IF lpForm1->OnMouseUp>0 THEN
                lpForm1->OnMouseUp(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF
            IF lpForm1->OnClick>0 THEN lpForm1->OnClick(lpForm1)

        CASE WM_RBUTTONDOWN
            IF lpForm1->OnMouseDown>0 THEN
                lpForm1->OnMouseDown(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_RBUTTONUP
            IF lpForm1->OnMouseUp>0 THEN
                lpForm1->OnMouseUp(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_KEYDOWN
            IF lpForm1->OnKeyDown>0 THEN lpForm1->OnKeyDown(LOWORD(wParam), 0, lpForm1)

        CASE WM_KEYUP
            IF lpForm1->OnKeyUp>0 THEN lpForm1->OnKeyUp(LOWORD(wParam), 0, lpForm1)

        CASE WM_CHAR
            IF lpForm1->OnKeyPress>0 THEN lpForm1->OnKeyPress(LOBYTE(wParam), lpForm1)

        CASE WM_SYSCOMMAND
            IF (wParam AND &hfff0) = SC_CLOSE THEN
                DIM AS integer Action=1                                      ' Default Action is quit
                IF lpForm1->OnClose>0 THEN lpForm1->OnClose(Action, lpForm1) ' Action passed by reference so
                IF Action=0 THEN RETURN 0                                    ' user can change default action
            END IF

        CASE WM_ENTERSIZEMOVE
            Sizing=True

        CASE WM_EXITSIZEMOVE
            lpForm1->FormReSize()
            Sizing=False
            IF lpForm1->OnResize>0 THEN
                lpForm1->OnResize(lpForm1)
                InvalidateRect(hWnd, NULL, True)
                RETURN 0
            END IF

        CASE WM_SIZE
            IF Sizing THEN RETURN 0
            IF (wParam=SIZE_MAXIMIZED) OR (wParam=SIZE_RESTORED) THEN
                lpForm1->FormReSize()
                IF lpForm1->OnResize>0 THEN
                    lpForm1->OnResize(lpForm1)
                    RETURN 0
                END IF
            END IF

        CASE WM_CLOSE

        CASE WM_DESTROY
            KillAllTimers()
            PostQuitMessage(0)

    END SELECT

    RETURN DefWindowProc(hWnd, wMsg, wParam, lParam)
END FUNCTION

'-------------------------------------------------------------------------------
' WndProc hooks for additional components
'-------------------------------------------------------------------------------
'
' ***Add additional WndProcs as required***
'

'-------------------------------------------------------------------------------
' Create new window class for project
'-------------------------------------------------------------------------------
FUNCTION CreateWindClass(hInst AS HINSTANCE) AS integer
DIM AS integer Result
DIM AS WNDCLASSEX wc

WITH wc
    .cbSize = SizeOf(WNDCLASSEX)
    .style = CS_HREDRAW OR CS_VREDRAW
    .lpfnWndProc = @MainWndProc
    .hInstance = hInst
    .hIcon = LoadIcon(0, IDI_APPLICATION)
    .hCursor = LoadCursor(0, IDC_ARROW)
    .hbrBackground = GetSysColorBrush(COLOR_BTNFACE)
    .lpszClassName = @"RQClass"
    .hIconSm = .hIcon
END WITH

    Result = RegisterClassEx(@wc)
    IF Result = 0 THEN ShowMessage("Register class error")
    RETURN Result
END FUNCTION

'-------------------------------------------------------------------------------
' Main startup code
'-------------------------------------------------------------------------------
FUNCTION WinMain(hInst AS HINSTANCE, hPrevInstance AS HINSTANCE, _
                            szCmdLine AS string, iCmdShow AS integer) AS integer
DIM AS integer Result=0

    IF CreateWindClass(hInst) = 0 THEN RETURN 0

    ConfigureComponents()
    CreateComponents()
    InitSystemTimers(lpForm1->Handle)
    HookTheMouse()

    lpForm1->Center                         ' You may wish to delete this line

    IF lpForm1->OnShow>0 THEN lpForm1->OnShow(lpForm1)

    Result = lpForm1->ShowModal             ' Show form & call default message handler

    ' You may want to change the above line to lpForm1->Show, and then provide
    ' your own function that, amongst other things, handles all window messages.

    UnHookTheMouse()

    RETURN Result
END FUNCTION

'-------------------------------------------------------------------------------
' *** MAIN ENTRY POINT ***
'-------------------------------------------------------------------------------
END WinMain(Application.hInstance, NULL, Command(), SW_NORMAL)


'-------------------------------------------------------------------------------
' Code for the component events
'-------------------------------------------------------------------------------
' #POPUP# Action the event chosen via the popup menu
SUB PopMenuSelect(Idx AS integer, Sender AS QRICHEDIT)
    SELECT CASE Idx
        CASE TEXT_SEL_ALL:  Sender.SelectAll
        CASE TEXT_COPY:     Sender.CopyToClipBoard
        CASE TEXT_CUT:      Sender.CutToClipboard
        CASE TEXT_PASTE:    Sender.PasteFromClipboard
        CASE FILE_SAVE
            Sender.SaveToFile("SaveTest.rtf")
            IF FileExists("SaveTest.rtf") THEN ShowMessage("'SaveTest.rtf' - File saved")
        CASE FILE_LOAD
            IF FileExists("LoadTest.rtf") THEN
                Sender.LoadFromFile("LoadTest.rtf")
            ELSE
                ShowMessage("'LoadTest.rtf' - File does not exist!")
            END IF
        CASE TEXT_COLOR
            SendMessage(Sender.Handle, EM_GETCHARFORMAT, SCF_DEFAULT, CAST(LPARAM, @CharFormat))
            Sender.SelectAll
            CharFormat.cbSize = SIZEOF(CharFormat)
            CharFormat.dwMask = &HFFFFFFFF              ' All = CFM_COLOR Or CFM_BOLD Or CFM_SIZE Or CFM_FACE
            CharFormat.dwEffects = CFE_BOLD OR CFE_ITALIC
            CharFormat.yHeight = 250                    ' 50 -> 450
            CharFormat.crTextColor = &hff
            CharFormat.szFaceName = "Courier" & CHR(0)
            SendMessage(Sender.Handle, EM_SETCHARFORMAT, SCF_SELECTION, CAST(LPARAM, @CharFormat))
    END SELECT
END SUB

SUB Initialise(Sender AS QFORM)
    FontNames(0) = "FixedSys"+CHR$(0): FontNames(1) = "Courier"+CHR$(0)
    FontNames(2) = "Lucida Console"+CHR$(0): FontNames(3) = "Terminal"+CHR$(0)
    FontNames(4) = "MS Serif"+CHR$(0): FontNames(5) = "MS Sans Serif"+CHR$(0)
    ' Add some plain text into the RichEdit
    lpRichEd1->AddStrings "A demo of RichEdit RTF text from Jacques Philippe"
    lpRichEd1->AddStrings ""
    lpRichEd1->AddStrings "Hit the 'RTF' button below to demo this text as random RTF text"
    lpRichEd1->AddStrings "...or..."
    lpRichEd1->AddStrings "use the popupmenu to load a demo file."
    lpRichEd1->AddStrings ""
    lpRichEd1->AddStrings "The quick brown fox jumps over the lazy dog"
    lpRichEd1->AddStrings "Now is the time for all good men to come to the aid of the party"
    lpRichEd1->AddStrings "Hello world!"
    RichEd1.Addstrings "          **** FINISHED ****"
END SUB

' Convert plain text to (random) Rich Text Format
SUB RandText(Sender AS QBUTTON)
DIM AS string sText, sFontName=SPACE(LF_FACESIZE)
DIM AS integer i, iLen, iChar, iEffect, iSelStart=0, iSelEnd=0, Addm=0

    iLen = SendMessage (RichEd1.Handle, WM_GETTEXTLENGTH, 0, 0)+1
    IF iLen<= 0 THEN EXIT SUB
    sText=SPACE(iLen)

    IF SendMessage(RichEd1.Handle, WM_GETTEXT, iLen, CAST(LPARAM, STRPTR(sText))) = 0 THEN
        ShowMessage ("ERROR: WM_GETTEXT")
        EXIT SUB
    END IF
    sText=rqReplaceSubStr(sText,CHR(13),"")
    sText=RTRIM(stExt)
    iLen=LEN(sText)

    Randomize(,3)

    CharFormat.cbSize = SIZEOF(CharFormat)
    SendMessage(RichEd1.Handle, EM_GETCHARFORMAT, SCF_DEFAULT, CAST(LPARAM, @CharFormat))
    CharFormat.dwMask = &HFFFFFFFF              ' All = CFM_COLOR Or CFM_BOLD Or CFM_SIZE Or CFM_FAC

    LockWindowUpdate(RichEd1.Handle)
    IF (CINT(sText[0])>32) AND (CINT(sText[0])<127) THEN Addm=True      ' For first char only iSelStart=0
    FOR i=1 TO iLen-1                                                   ' Loop from 2nd char on
        iChar=CINT(sText[i])
        SELECT CASE iChar
            CASE 33 TO 126
                IF Addm=False THEN
                    iSelStart=i-1                                       ' Preceding char - start
                    Addm=True
                END IF
            CASE ELSE
                IF iSelEnd=0 THEN iSelEnd=i                             ' Last char - end marker
        END SELECT
        IF (Addm=True) AND (iSelEnd>0) THEN
            iEffect = 0                                                 ' Add some random special effects?
            IF Int(Rnd * 5) = 0 THEN iEffect = iEffect OR CFE_BOLD
            IF Int(Rnd * 6) = 0 THEN iEffect = iEffect OR CFE_ITALIC
            IF Int(Rnd * 7) = 0 THEN iEffect = iEffect OR CFE_UNDERLINE
            IF Int(Rnd * 8) = 0 THEN iEffect = iEffect OR CFE_STRIKEOUT

            CharFormat.dwEffects = iEffect
            CharFormat.crTextColor = (Int(240 * Rnd) SHL 16) + (Int(240 * Rnd) SHL 8) + Int(240 * Rnd)
            CharFormat.yHeight = 50 + Int(Rnd * 401)                    ' min 50, max 450 : 1440 per inch
            CharFormat.szFaceName = FontNames(Int(RND * 6))

            SendMessage(RichEd1.Handle, EM_SETSEL, iSelStart, iSelEnd)
            IF SendMessage(RichEd1.Handle, EM_SETCHARFORMAT, SCF_SELECTION, CAST(LPARAM, @CharFormat)) = 0 THEN
                ShowMessage("ERROR: EM_SETCHARFORMAT")
                EXIT SUB
            END IF
            iSelStart=0: iSelEnd=0: Addm=False
        END IF
    NEXT i
    LockWindowUpdate(0)
    sText=""
END SUB

SUB Done(Sender AS QBUTTON)
    Application.Terminate
END SUB
