$OPTIMIZE ON
$TYPECHECK ON
$APPTYPE CGI
$INCLUDE "qcgi.inc"
$ESCAPECHARS ON

DECLARE SUB main()

DECLARE SUB PrintHeader(myTitle$ AS STRING)
DECLARE SUB PrintFooter()
DECLARE FUNCTION GetUserName() AS STRING
DECLARE SUB PrintInfo()

CREATE CGI AS QCGI
	InitCGI(cgiInputDefault, cgiConvertAuto)
END CREATE

CALL main()

SUB main()
	CALL PrintHeader("CGI Info")
	PRINT "\t\t<h1>Hello, " + GetUserName() + "</h1>"
	PRINT "\t\t<h2>Here are your environmental varibles</h2>"
	CALL PrintInfo()
	CALL PrintFooter()
END SUB

SUB PrintHeader(myTitle$ AS STRING)
	PRINT "Content-type: text/html; charset=iso-8859-1\n\n"
	PRINT "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">"
	PRINT "<html>"
	PRINT "\t<head>"
	PRINT "\t\t<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">"
	PRINT "\t\t<title>"
	PRINT "\t\t\t" + myTitle$
	PRINT "\t\t</title>"
	PRINT "\t</head>"
	PRINT "\t<body>"
END SUB

SUB PrintFooter()
	PRINT "\t</body>"
	PRINT "</html>"
	PRINT
END SUB

FUNCTION GetUserName() AS STRING
	Result = CGI.GetValue("name")
END FUNCTION

SUB PrintInfo()
	PRINT "\t\t<ul>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tHTTP_Accept: " + CGI.GetCGIAccept()
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tAuthType: " + CGI.GetCGIAuthType() 
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tContentLength: " + STR$(CGI.GetCGIContentLength())
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tContentType: " + CGI.GetCGIContentType()
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tCookie: " + CGI.GetCGICookie()
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tGatewayInterface: " + CGI.GetCGIGatewayInterface()
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tPathInfo: " + CGI.GetCGIPathInfo()
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tPathTranslated: " + CGI.GetCGIPathTranslated()
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tReferer: " + CGI.GetCGIReferer() 
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tRemoteAddr: " + CGI.GetCGIRemoteAddr()
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tRemoteHost: " + CGI.GetCGIRemoteHost()
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tRemoteIdent: " + CGI.GetCGIRemoteIdent()
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tRemoteUser: " + CGI.GetCGIRemoteUser()
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tRequestMethod: " + CGI.GetCGIRequestMethod()
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tScriptName: " + CGI.GetCGIScriptName()
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tServerSoftware: " + CGI.GetCGIServerSoftware()
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tServerName: " + CGI.GetCGIServerName()
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tServerPort: " + CGI.GetCGIServerPort()
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tServerProtocol: " + CGI.GetCGIServerProtocol()
	PRINT "\t\t\t</li>"
	PRINT "\t\t\t<li>"
		PRINT "\t\t\t\tUserAgent: " + CGI.GetCGIUserAgent()
	PRINT "\t\t\t</li>"
	PRINT "\t\t</ul>"
END SUB
