
'/////////////////////////////////////////////////////////////////////////////// 
'// 
'// Project Name : QPicture Object for RapidQ 
'// Version      : 2.04.2006.20 
'// Author       : Don67geo@Yahoo.com 
'// Date         : April 20th, 2006 
'// 
'/////////////////////////////////////////////////////////////////////////////// 
$typecheck ON 

$ifndef QPICTURE_INC 
$define QPICTURE_INC 

'____enum_PICTYPE 
const PICTYPE_UNINITIALIZED = -1 
const PICTYPE_NONE          = 0 
const PICTYPE_BITMAP        = 1 
const PICTYPE_METAFILE      = 2 
const PICTYPE_ICON          = 3 
const PICTYPE_ENHMETAFILE   = 4 
'____enum_PICTYPE 

'/////////////////////////////////////////////////////////////////////////////// 
'// 
'// WIN32 API calls declaration 
'// 
'/////////////////////////////////////////////////////////////////////////////// 

declare function GetDeviceCaps lib "gdi32" alias "GetDeviceCaps" _ 
        (hdc as long, nIndex as long) as long 
declare sub GlobalFree Lib "kernel32" alias "GlobalFree" (hMem As Long) 
declare function GlobalAlloc Lib "kernel32" alias "GlobalAlloc" _ 
        (wFlags As Long, dwBytes As Long) As Long 
declare function OleInitialize lib "ole32" alias "OleInitialize" _ 
        (pvReserved   as long) as long 
declare sub OleUninitialize lib "ole32" alias "OleUninitialize" 
declare function CreateStreamOnHGlobal lib "ole32" alias "CreateStreamOnHGlobal" _ 
        (hGlobal as long, fDeleteOnRelease as integer,ppStream as long) as long 
declare sub OleLoadPicture lib "oleaut32" alias "OleLoadPicture" _ 
        (ppStream as long, lSize as long, fRunmode as integer,riid as long, _ 
         ppPic as long) 
declare function GetDC Lib "user32" alias "GetDC" (hwnd As Long) As Long 
declare function ReleaseDC Lib "user32" alias "ReleaseDC" (hwnd As Long) As Long 
declare function STDCall lib "user32" alias "CallWindowProcA" _ 
        (fnPtr as long, pA as long, pB as long, pC as long, pD as long) as long 

defbyte MCallOpcodes (0 To 51) = _ 
    { _ 
      &H55,&H89,&HE5,&H8B,&H75,&H08,&H8B,&H06,&H89,&HC3,&HC1,&HE0, _ 
      &H02,&H01,&HC6,&H81,&HFB,&H00,&H00,&H00,&H00,&H74,&H0B,&HFF, _ 
      &H36,&H81,&HEE,&H04,&H00,&H00,&H00,&H4B,&H75,&HF5,&H8B,&H45, _ 
      &H0C,&H8B,&H4D,&H10,&H50,&H8B,&H00,&HFF,&H14,&H08,&H89,&HEC, _ 
      &H5D,&HC2,&H10,&H00 _ 
    } 
defint pMCall = varptr(MCallOpcodes(0)) 
dim scratch as qmemorystream 

functioni comcall (...) as long 
      defint n 
      dim Arg(0 to (ParamValCount-2)) as long 
      if ParamValCount < 2 then 
         result = 0 
         exit function 
      end if 
      Arg(0) = ParamValCount-2 
      if ParamValCount > 2 then 
         for n = 3 to ParamValCount 
             Arg(n-2) = ParamVal(n) 
         next n 
      end if 
      result=STDCall(pMCall,varptr(Arg(0)),ParamVal(2),ParamVal(1),0) 
end function 


'/////////////////////////////////////////////////////////////////////////////// 
'// 
'// QPicture custom object class 
'// 
'/////////////////////////////////////////////////////////////////////////////// 
type QPicture extends QObject 

     Parent as long 
     Palette as long property set set_hpal 
     KeepOriginalFormat as long property set set_KeepOriginalFormat 

'____BEGIN__PROTECTED__SECTION____ 

     vtbl as long 
     X    as long 
     Y    as long 

     sub reload 
         deflng ppPix,ppStream,hGlobal,dwSize=scratch.size 
         deflng IID_IPicture(0 to 3) = _ 
                { _ 
                  &h7BF80980, _ 
                  &h101ABF32, _ 
                  &hAA00BB8B, _ 
                  &hAB0C3000  _ 
                } 
         QPicture.vtbl=0: QPicture.X=0: QPicture.Y=0 
         if dwSize=0 then exit sub 
         hGlobal=GlobalAlloc(0,dwSize) 
         memcpy(hGlobal,scratch.pointer,dwSize) 
         scratch.clear 
         CreateStreamOnHGlobal(hGlobal,1,varptr(ppStream)) 
         if ppStream<>0 then 
            OleLoadPicture(ppStream,dwSize,0,_ 
                           varptr(IID_IPicture(0)),varptr(ppPix)) 
            QPicture.vtbl=ppPix 
            comcall(8,ppStream) 
         end if 
     end sub 

'____END__PROTECTED__SECTION____ 

     sub LoadFromFile(filename as string) 
         dim tmpfile as qfilestream 
             tmpfile.Open(filename,0) 
         scratch.clear 
         scratch.copyfrom(tmpfile,0) 
         tmpfile.close 
         QPicture.reload 
     end sub 

     sub LoadFromResource(resnum as long) 
         scratch.clear 
         scratch.ExtractRes(resnum) 
         QPicture.reload 
     end sub 

     sub Free 
         deflng comret=comcall(8,QPicture.vtbl) 
     end sub 

     function Handle as long 
         result=0 
         deflng RetFn 
         deflng comret=comcall(12,QPicture.vtbl,varptr(RetFn)) 
         result=RetFn 
     end function 

     function GetPalette as long 
         result=0 
         deflng RetFn 
         deflng comret=comcall(16,QPicture.vtbl,varptr(RetFn)) 
         result=RetFn 
     end function 

     function PictureType as long 
         result=0 
         deflng RetFn 
         deflng comret=comcall(20,QPicture.vtbl,varptr(RetFn)) 
         result=RetFn 
     end function 

     function Height as long 
         result=0 
         deflng comret=comcall(28,QPicture.vtbl,varptr(QPicture.Y)) 
         deflng RetFn,hdc=GetDC(QPicture.Parent) 
         RetFn=(QPicture.Y*GetDeviceCaps(hdc,90))\2540 
         ReleaseDC(QPicture.Parent) 
         result=RetFn 
     end function 

     function Width as long 
         result=0 
         deflng comret=comcall(24,QPicture.vtbl,varptr(QPicture.X)) 
         deflng RetFn,hdc=GetDC(QPicture.Parent) 
         RetFn=(QPicture.X*GetDeviceCaps(hdc,88))\2540 
         ReleaseDC(QPicture.Parent) 
         result=RetFn 
     end function 

     sub Render(Handle as long, x as long, y as long, cx as long, _ 
                cy as long, cR as QRECT) 
         dim cRect(4) as long 
         deflng pcRect=varptr(cRect(0)) 
         cRect(0)=cR.left 
         cRect(1)=cR.top 
         cRect(2)=cR.right 
         cRect(3)=cR.bottom 
         deflng hdc=GetDC(Handle) 
         deflng comret=comcall(32,QPicture.vtbl,hdc,x,y,cx,cy,0,_ 
                           QPicture.Y,QPicture.X,-QPicture.Y,pcRect) 
         ReleaseDC(Handle) 
     end sub 

     property set set_hPal(hPal as long) 
         deflng comret=comcall(36,QPicture.vtbl,hPal) 
     end property 

     function DC as long 
         result=0 
         deflng RetFn 
         deflng comret=comcall(40,QPicture.vtbl,varptr(RetFn)) 
         result=RetFn 
     end function 

     sub SelectPicture(psrcDC as long, pdstDC as long, poutBMP as long) 
         deflng comret=comcall(44,QPicture.vtbl,psrcDC,pdstDC,poutBMP) 
     end sub 

     function GetKeepOriginalFormat as long 
         result=0 
         deflng RetFn 
         deflng comret=comcall(48,QPicture.vtbl,varptr(RetFn)) 
         result=RetFn 
     end function 

     property set set_KeepOriginalFormat(keep as integer) 
         deflng comret=comcall(52,QPicture.vtbl,keep) 
     end property 

     sub PictureChanged 
         deflng comret=comcall(56,QPicture.vtbl) 
     end sub 

     sub SaveToStream(pStream as long, bSaveMemCopy as integer, pSize as long) 
         deflng comret=comcall(60,QPicture.vtbl,pStream,bSaveMemCopy,pSize) 
     end sub 

     function Attributes as long 
         result=0 
         deflng RetFn 
         deflng comret=comcall(64,QPicture.vtbl,varptr(RetFn)) 
         result=RetFn 
     end function 

     function Valid as integer 
         result=iif(QPicture.vtbl<>0,1,0) 
     end function 

     constructor 
         vtbl=0 
     end constructor 
end type      


$endif 'QPICTURE_INC 
