' ======================================= '
'	{  Day$ Function  }

'	Parameter : Date$ Format String ; Ex. Day$(Date$), Day$("3-21-2002")
'	Return Value : Day Of Week String ; Ex. Monday, Tuesday, Sunday,.. etc.
'	Note : If Parameter is not exist-date, It will Return Value = "-"

'	Support Year : 1980 up
'	Bug Report To: dragon_html@yahoo.com

'	Extra : Simple Calendar SourceCode in this file.
' ======================================= '


$typecheck on
$escapechars on

 DEFINT	SUN = 1,	MON = 2
 DEFINT	TUE = 3,	WED = 4
 DEFINT	THU = 5,	FRI = 6
 DEFINT	SAT = 7

 CONST	FirstYear = 1980	
 CONST	Feb29 = 0
 DEFINT	FirstDay = TUE

 DEFINT N
 DEFSTR MONTH$(1 to 12) = { "January","February","March","April","May","June", _
 "July","August","September","October","November","December "}

	Function PeriodFeb29Year( y& as integer ) As Integer
		PeriodFeb29Year = y& MOD 4 '-- 0,1,2,3
	End Function

		Function FebDay( order& as integer ) As Integer
			IF order&=0	THEN	:FebDay=29
						ELSE	:FebDay=28
			END IF
		End Function

	 Function AmountDayInMonth( num& as integer, y& as integer ) as integer
		SELECT CASE num&
			case 1,3,5,7,8,10,12: AmountDayInMonth = 31
			case 2: AmountDayInMonth = FebDay(PeriodFeb29Year( y& ))
			case 4,6,9,11: AmountDayInMonth = 30
		END SELECT
	 End Function

	 Function Jan1DayInYear(y& as integer) As Integer
		SELECT Case (y&-FirstYear) MOD 28 '-- Period of ->TuesDay Feb 29
		case 0,5,11,22: Jan1DayInYear = TUE
		case 6,12,17,23: Jan1DayInYear = WED
		case 1,7,18,24: Jan1DayInYear = THU
		case 2,8,13,19: Jan1DayInYear = FRI
		case 3,14,20,25: Jan1DayInYear = SAT
		case 4,9,15,26: Jan1DayInYear = SUN
		case 10,16,21,27: Jan1DayInYear = MON
		END SELECT
	 End Function

	 Function DayOrder( d&, n& ) as integer '-- n& must -6 to 6
		IF d&+n&>7 THEN
			 DayOrder = d&+n&-7
		ELSEIF d&+n&<1 THEN
			 DayOrder = d&+n&+7
		ELSE
			DayOrder = d&+n&
		END IF
	 End Function

	 Function LastDayInBeforeMonth(d& as integer,m& as integer, y& as integer) as integer
	 Dim C& As Integer
		SELECT CASE m&
		case 9,12:	C&=-3 '-- case 9 -> 31 August Year y&
		case 4,7	C&=-2
		case 10,1:	C&=-1 '-- case 1 -> 31 December Year Before y&
		case 5:		C&=0
		case 8:		C&=1
		case 2,3,11:	C&=2
		case 6:		C&=3
		END SELECT
		C& = DayOrder(d&,C&)
		IF PeriodFeb29Year(y&)=Feb29 THEN
			IF m&>2 THEN ' after feb
				LastDayInBeforeMonth = DayOrder(C&,1)
			ELSE
				LastDayInBeforeMonth = C&
			END IF
		ELSE
			LastDayInBeforeMonth = C&
		END IF
	 End Function

' ======================================= '
'		Day$ Function
' ======================================= '
 Function Day$(d$) As String
 DEFINT year& = VAL(Field$(d$,"-",3)) ,month& = VAL(Field$(d$,"-",1)), day& = VAL(Field$(d$,"-",2))
 DEFINT d& = Jan1DayInYear( year& ) '-- Day of -> Jan 1, year&
 	IF (year&<1980) OR (month&<1) OR (month&>12) OR (day&<1) OR (day&>31) THEN
		Day$="-"
	ELSEIF day& > AmountDayInMonth( month&, year& ) THEN
		Day$ = "-"
	ELSE
		d& = LastDayInBeforeMonth(d&, month&, year&)
		d& = DayOrder(d&,day& MOD 7)
		SELECT Case d&
			case 1:D$="Sun"	'-- "sun"
			case 2:D$="Mon"	'-- "mon"
			case 3:D$="Tues"	'-- "tue"
			case 4:D$="Wednes"	'-- "wed"
			case 5:D$="Thurs"		'-- "thu"
			case 6:D$="Fri"			'-- "fri"
			case 7:D$="Satur"		'-- "sat"
		END SELECT
		Day$=D$+"day"
	END IF
 End Function

	 Function Day(d$) As INTEGER '-- 1,2,3,4,5,6,7
	 DEFINT year& = VAL(Field$(d$,"-",3)) ,month& = VAL(Field$(d$,"-",1)), day& = VAL(Field$(d$,"-",2))
	 DEFINT d& = Jan1DayInYear( year& ) '-- Day of -> Jan 1, year&
		IF (year&<1980) OR (month&<1) OR (month&>12) OR (day&<1) OR (day&>31) THEN
			Day=0
		ELSEIF day& > AmountDayInMonth( month&, year& ) THEN
			Day=0
		ELSE
			d& = LastDayInBeforeMonth(d&, month&, year&)
			Day = DayOrder(d&,day& MOD 7)
		END IF
	 End Function

' ======================================= '
'		SIMPLE CALENDAR
' ======================================= '

CONST True = 1
CONST False = 0
CONST wiBtn = 42
CONST hiBtn = wiBtn - 10
CONST Cal$ = "Simple Calendar : "

' - - - - - - - - - - - - - - - - - - - - OBJECT - - - - - - - - - - - - - - - - - - - - '
Dim popMonth As QPopupMenu
	Dim imonth(11) As QMenuItem

Dim Form As QForm
	Dim pnCalendar As QPanel
		Dim pn7Day As QPanel
			Dim pnDay(6) As QPanel
		Dim Btn(36) As QCoolBtn
	Dim pnMonth As QPanel
		Dim btnMonthDown As QCoolBtn
		Dim btnDsMonth As QCoolBtn
		Dim btnMonthUp As QCoolBtn
	Dim pnYear As QPanel
		Dim btnYearDownTen As QCoolBtn
		Dim btnYearDownOne As QCoolBtn
		Dim btnDsYear As QCoolBtn
		Dim btnYearUpOne As QCoolBtn
		Dim btnYearUpTen As QCoolBtn

' - - - - - - - - - - - - - - - - - - - -  EVENT - - - - - - - - - - - - - - - - - - - - '
DEFINT curYear&=Val(Field$(Date$,"-",3))
DEFINT curMonth&=Val(Field$(Date$,"-",1))
DEFINT curDate&=Val(Field$(Date$,"-",2))
DEFINT NumBtn&=0

SUB Day2Calendar
	DEFINT d&=1, m&=btnDsMonth.Tag, y&=Val(btnDsYear.Caption)
	DEFINT FirstDayMonth = Day(Str$(m&)+"-"+Str$(d&)+"-"+Str$(y&))
	DEFINT DayBegin = (FirstDayMonth-1)*6
			for N=1 to 7
				Btn(N).Caption = ""
			next
			   for N=29 to 37
				Btn(N).Caption = ""
			   next
			for N=1 to AmountDayInMonth(m&,y&)
				Btn(N+FirstDayMonth-1).Caption = Str$(N)
			next
		'-- Show ToDay --'
		IF (y&=curYear&) AND (m&=curMonth&) THEN
			NumBtn& = FirstDayMonth+curDate&-1
			Btn( NumBtn& ).Font.Color = &H0000FF '-- Red
		ELSEIF NumBtn&<>0 THEN
			Btn( NumBtn& ).Font.Color = &H000000 '-- Black
			NumBtn& = 0
		END IF
END SUB

	SUB btnDsMonthMd(Button%, X%, Y%, Shift%)
		IF Button%=1 THEN
			popMonth.popup(Screen.MouseX,Screen.MouseY)
		END IF
	END SUB

	SUB btnMonthDownCk
		IF btnDsMonth.Tag=1 THEN
		btnDsMonth.Caption = MONTH$(12)
		btnDsMonth.Tag = 12
		ELSE
		btnDsMonth.Tag = btnDsMonth.Tag - 1
		btnDsMonth.Caption = MONTH$(btnDsMonth.Tag)
		END IF
		Day2Calendar
	END SUB

	SUB btnMonthUpCk
		IF btnDsMonth.Tag=12 THEN
		btnDsMonth.Caption = MONTH$(1)
		btnDsMonth.Tag = 1
		ELSE
		btnDsMonth.Tag = btnDsMonth.Tag + 1
		btnDsMonth.Caption = MONTH$(btnDsMonth.Tag)
		END IF	
		Day2Calendar
	END SUB

	SUB iMonthCk( Sender As QMenuItem )
		btnDsMonth.Tag = Sender.Tag
		btnDsMonth.Caption = Sender.Caption
		Day2Calendar
	END SUB

SUB btnYearDownTenCk
IF Val(btnDsYear.Caption)<>1980 THEN
	IF Val(btnDsYear.Caption)-10 < 1980 THEN
		btnDsYear.Caption = "1980"
	ELSE
		btnDsYear.Caption = Str$(Val(btnDsYear.Caption)-10)
	END IF
	Day2Calendar
END IF
END SUB

SUB btnYearDownOneCk
IF Val(btnDsYear.Caption)<>1980 THEN
	IF Val(btnDsYear.Caption) > 1980 THEN
		btnDsYear.Caption = Str$(Val(btnDsYear.Caption)-1)
	END IF
	Day2Calendar
END IF
END SUB

SUB btnYearUpOneCk
IF Val(btnDsYear.Caption)<>2099 THEN
	IF Val(btnDsYear.Caption) < 2099 THEN
		btnDsYear.Caption = Str$(Val(btnDsYear.Caption)+1)
	END IF
	Day2Calendar
END IF
END SUB

SUB btnYearUpTenCk
IF Val(btnDsYear.Caption)<>2099 THEN
	IF Val(btnDsYear.Caption)+10 > 2099 THEN
		btnDsYear.Caption = "2099"
	ELSE
		btnDsYear.Caption = Str$(Val(btnDsYear.Caption)+10)
	END IF
	Day2Calendar
END IF
END SUB

	for n=0 to 11
		iMonth(n).Caption = MONTH$(n+1)
		iMonth(n).onClick = iMonthCk
		iMonth(n).Tag = n+1
	next
		for n=0 to 11
			popMonth.Additems imonth(n)
		next

' - - - - - - - - - - - - - - - - - - - - PROPERTY - - - - - - - - - - - - - - - - - - - - '
WITH Form
.Width = 390:.Height = 352
.Caption = "Simple Calendar 1.0"
end WITH
	WITH pnCalendar :.Parent = Form
	.Top = 25:.Left = 45:.Width = wiBtn*7:.Height = (hiBtn*7)+10
	.BevelOuter = False
	end WITH
		WITH pn7Day:.Parent = pnCalendar
		.Width = pnCalendar.ClientWidth:.Height = hiBtn
		.BevelOuter = False
		end WITH
	WITH pnMonth:.Parent = Form
	.Top = 273:.Left = pnCalendar.Left:.Width = pnCalendar.ClientWidth - 160:.Height = 28
	.BevelOuter = False
	end WITH
		WITH btnMonthDown:.Parent = pnMonth:.Caption = "<"
		.Width = 20
		.Align = 3
		.onClick = btnMonthDownCk
		end WITH
		WITH btnDsMonth:.Parent = pnMonth:.Caption = MONTH$(1) '-- Display Month
		.Align = 5
		.Tag = Val(Field$(Date$,"-",1))
		.Caption = MONTH$(.Tag)
		.OnMouseDown = btnDsMonthMd
		end WITH
		WITH btnMonthUp:.Parent = pnMonth:.Caption = ">"
		.Width = 20
		.Align = 4
		.onClick = btnMonthUpCk
		end WITH
	WITH pnYear:.Parent = Form
	.Top = pnMonth.Top:.Left = pnMonth.Left+pnMonth.Width+5:.Width = 155:.Height = pnMonth.Height
	.BevelOuter = False
	end WITH
		WITH btnYearDownTen:.Parent = pnYear:.Caption = "<<"
		.Align = 3
		.Width = 24
		.onClick = btnYearDownTenCk
		end WITH
		WITH btnYearDownOne:.Parent = pnYear:.Caption = "<"
		.Width = 20
		.Align = 3
		.onClick = btnYearDownOneCk
		end WITH
		WITH btnDsYear:.Parent = pnYear:.Caption = Field$(Date$,"-",3) '-- Display Year
		.Align = 5
		end WITH
		WITH btnYearUpOne:.Parent = pnYear:.Caption = ">"
		.Width = 20
		.Align = 4
		.onClick = btnYearUpOneCk
		end WITH
		WITH btnYearUpTen:.Parent = pnYear:.Caption = ">>"
		.Width = 24
		.Align = 4
		.onClick = btnYearUpTenCk
		end WITH

	DEFSTR dayweek(0 to 6)={"sun","mon","tue","wed","thu","fri","sat"}
	for n=0 to 6 '-- Day Header
		pnDay(n).Parent=pn7Day
		pnDay(n).Left = wiBtn*n
		pnDay(n).Width = wiBtn
		pnDay(n).Height = pn7Day.ClientHeight
		pnDay(n).BevelOuter = False
		pnDay(n).Color = &HCCCCFF
		pnDay(n).Caption = dayweek(n)
	next

	for n=1 to 37 '-- Day
		Btn(n).Parent = pnCalendar
		Btn(n).Left = wiBtn*((n-1) MOD 7)
		Btn(n).Top = hiBtn*((n-1) \ 7)+pn7Day.Height
		Btn(n).Width = wiBtn
		Btn(n).Height = hiBtn
		Btn(n).Flat = True
		Btn(n).Caption = str$(n)
	next

' - - - - - - - - - - - - - - - - - - - - DISPLAY - - - - - - - - - - - - - - - - - - - - '
	Day2Calendar
	Form.Center
	Form.ShowModal


' ======================================= '
'		Day$ Function Example
' ======================================= '
'	 sub printDay( s$ as string )
'		print s$;" : ";Day$( s$ )
'	 end sub

'print "Today is : ";Day$(Date$)
'print "3-3-2004 is "+Day$("3-3-2004")
'printDay("10-5-2038")
'printDay("01-8-2039")
'printDay("1-8-2039")
'printDay("6-30-2037")
'printDay("0-30-2004") '-- FALSE by Date = 0
'printDay("2-29-2003") '-- FALSE by Date =29 in Year Which Feb28
'printDay("6-28-1945") '-- FALSE by Year Lower 1980


' ====================================================== '
'		Simple Calendar Source Code
' ====================================================== '
'	sub CalendarStr$( m& as integer, y& as integer )
'	DIM FirstDayMonth AS INTEGER
'	DIM S$ AS STRING
'	DEFINT d&=1
'	?""
'	?"   < ";MONTH$(m&);" ";STR$(y&);" >"
'	?"   sun   mon   tue   wed   thu   fri   sat"
'			FirstDayMonth = Day(Str$(m&)+"-"+Str$(d&)+"-"+Str$(y&))
'			S$=String$((FirstDayMonth-1)*6," ")
'			for N=1 to AmountDayInMonth(m&,y&)
'				S$=S$+String$(6-LEN(STR$(N))," ")+STR$(N)
'				IF DayOrder(N,FirstDayMonth-1) MOD 7 = 0 THEN
'					S$ = S$+"\r\n"
'				END IF
'			next
'	?S$
'	end sub

'	CalendarStr$(2,2002) '-- Month,  Year
'	CalendarStr$(3,2004)
'	CalendarStr$(6,2008)
'	CalendarStr$(8,1999)
'	CalendarStr$(12,1980)
'	INPUT N