'-------------------------------------------------------------------------------
' ShapeForm demo .. uses Pixel(0,0) of the bitmap as the Transparency color
' (bottom left pixel) Displays for a preset 5 seconds then terminates.
'
' FreeBasic code generated by RapidFRM v1.82
'-------------------------------------------------------------------------------
#INCLUDE "windows.bi"
#INCLUDE "win/commctrl.bi"
InitCommonControls()

#INCLUDE "win/RQInclude.bi"

#DEFINE SPLASH      "Splash.bmp"
#DEFINE TIME_DELAY  5000                        ' 5 secs

DIM SHARED AS hBITMAP hBmp

'-------------------------------------------------------------------------------
' Global data from Form designer sheet
'-------------------------------------------------------------------------------
DIM SHARED AS QFORM Form1
DIM SHARED AS QFORM PTR lpForm1 = @Form1
DIM SHARED AS QTIMER Timer1
DIM SHARED AS QTIMER PTR lpTimer1 = @Timer1

'-------------------------------------------------------------------------------
' Forward declarations for component events 
'-------------------------------------------------------------------------------
DECLARE SUB ShapeForm(Sender AS QFORM)
DECLARE SUB PaintShape(Sender AS QFORM)
DECLARE SUB DoTimer(Sender AS QTIMER)

'-------------------------------------------------------------------------------
' Configure components
'-------------------------------------------------------------------------------
SUB ConfigureComponents

    lpForm1->ObjIndex = 0
    lpForm1->BorderStyle = bsNone
    lpForm1->OnShow = CAST(ANY PTR, @ShapeForm)
    lpForm1->OnPaint = CAST(ANY PTR, @PaintShape)
    

    lpTimer1->ObjIndex = 1
    lpTimer1->Enabled = False
    lpTimer1->Interval = TIME_DELAY       
    lpTimer1->OnTimer = CAST(ANY PTR, @DoTimer)

END SUB

'-------------------------------------------------------------------------------
' Create components
'-------------------------------------------------------------------------------
SUB CreateMainMenu
END SUB

SUB CreatePopupMenus
END SUB

SUB CreateComponents
DIM AS UINT StdStyle, ExtStyle=0
DIM AS string ObjCaption

    lpForm1->PreSetConfig()
    StdStyle=lpForm1->objStyle
    IF lpForm1->BorderStyle > bsDialog THEN ExtStyle=WS_EX_TOOLWINDOW

    lpForm1->Handle = CreateWindowEx(ExtStyle, "RQClass", lpForm1->Caption, StdStyle, _
                    lpForm1->Left, lpForm1->Top, lpForm1->Width, lpForm1->Height, _
                    0, 0, Application.hInstance, 0)
    Application.hMainForm = lpForm1->Handle
    lpForm1->PostConfig()

    lpTimer1->Parent=lpForm1->Handle
    SetTimer(lpForm1->Handle, lpTimer1->ObjIndex, lpTimer1->Interval, 0)

    CreateMainMenu()
    CreatePopupMenus()
END SUB

'-------------------------------------------------------------------------------
' Remove Timers on Exit
'-------------------------------------------------------------------------------
SUB KillAllTimers
    KillTimer(Application.hMainForm, SYS_TIMER_IDX)
    lpTimer1->Enabled=False
    KillTimer(lpForm1->Handle, lpTimer1->ObjIndex)
END SUB

'-------------------------------------------------------------------------------
' System timer - Display hints
'-------------------------------------------------------------------------------
SUB SysDisplayHint(Parent AS HWND, HintString AS string)
DIM AS TOOLINFO ti

    ti.cbSize=sizeof(ti)
    ti.uFlags=TTF_SUBCLASS: ti.hwnd=Parent
    ti.hinst=NULL: ti.lpszText=STRPTR(HintString)
    GetClientRect(Parent, @ti.rect)
    SendMessage(Application.hWndTTip, TTM_ADDTOOL, 0, CAST(LPARAM, @ti))	
END SUB

SUB CheckSystemTimers
STATIC AS HWND TT_LastHWND
DIM AS HWND TT_hWnd
DIM AS Point TT_pnt

    TT_pnt.X=Screen.MouseX: TT_pnt.Y=Screen.MouseY
    TT_hWnd=WindowFromPoint(TT_pnt)
    IF TT_LastHWND<>TT_hWnd THEN
        TT_LastHWND=TT_hWnd
        SELECT CASE TT_hWnd
            CASE lpForm1->Handle
                IF lpForm1->ShowHint THEN
                    SysDisplayHint(lpForm1->Handle, lpForm1->Hint)
                END IF
        END SELECT
    END IF
END SUB

'-------------------------------------------------------------------------------
' Start of Main WndProc code
'-------------------------------------------------------------------------------

SUB CheckWmTimers(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
    SELECT CASE wParam
        CASE App_Timer.ObjIndex:  CheckSystemTimers
        CASE lpTimer1->ObjIndex
            IF (lpTimer1->Enabled) AND (lpTimer1->OnTimer>0) THEN
                lpTimer1->OnTimer(lpTimer1)
            END IF
    END SELECT
END SUB

SUB CheckWmCommandMsg(wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmNotifyMsg(wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmPaintMsg(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
    IF lpForm1->OnPaint>0 THEN lpForm1->OnPaint(lpForm1)
END SUB

FUNCTION CheckBtnColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
' Only for OwnerDraw buttons
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

FUNCTION CheckStaticColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

FUNCTION CheckEditColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

FUNCTION CheckListBoxColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

SUB CheckWmObjScroll(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckSocketEvent(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

' Hook into the Popup menus for all of your components here
SUB CheckWmContextMenu(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmHitTest(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmDrawItem(wParam AS WPARAM, lParam AS LPARAM)
END SUB

FUNCTION MainWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
STATIC AS integer Sizing
    
    SELECT CASE wMsg
        CASE WM_CREATE
            Sizing=False

        CASE WM_COMMAND
            IF lParam<>0 THEN
                CheckWmCommandMsg(wParam, lParam)
            ELSE
                ' IF HIWORD(wParam)=0 THEN
                '     Menu message code goes here.....
                ' ELSE
                '     Accelerator message code goes here...
                ' END IF
            END IF

        CASE WM_NOTIFY
            CheckWmNotifyMsg(wParam, lParam)

        CASE WM_PAINT
            CheckWmPaintMsg(hWnd, wMsg, wParam, lParam)

        CASE WM_TIMER
            CheckWmTimers(hWnd, wMsg, wParam, lParam)

        CASE WM_NCHITTEST
            CheckWmHitTest(hWnd, wMsg, wParam, lParam)

        CASE WM_HSCROLL, WM_VSCROLL
            IF lParam<>0 THEN CheckWmObjScroll(hWnd, wMsg, wParam, lParam)

        CASE WM_CTLCOLORBTN
            RETURN CheckBtnColor(wParam, lParam)

        CASE WM_CTLCOLOREDIT
            RETURN CheckEditColor(wParam, lParam)

        CASE WM_CTLCOLORSTATIC
            RETURN CheckStaticColor(wParam, lParam)

        CASE WM_CTLCOLORLISTBOX
            RETURN CheckListBoxColor(wParam, lParam)

        CASE WM_DRAWITEM
            CheckWmDrawItem(wParam, lParam)

        CASE WM_CONTEXTMENU
            CheckWmContextMenu(hWnd, wMsg, wParam, lParam)

        CASE WM_SOCK_NOTIFY
            CheckSocketEvent(hWnd, wMsg, wParam, lParam)

        CASE WM_MOUSEMOVE
            IF lpForm1->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpForm1->hCursor)
            END IF
            IF lpForm1->OnMouseMove>0 THEN
                lpForm1->OnMouseMove(LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_LBUTTONDBLCLK
            IF lpForm1->OnClick>0 THEN lpForm1->OnClick(lpForm1)

        CASE WM_LBUTTONDOWN
            IF lpForm1->OnMouseDown>0 THEN
                lpForm1->OnMouseDown(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_LBUTTONUP
            IF lpForm1->OnMouseUp>0 THEN
                lpForm1->OnMouseUp(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF
            IF lpForm1->OnClick>0 THEN lpForm1->OnClick(lpForm1)

        CASE WM_RBUTTONDOWN
            IF lpForm1->OnMouseDown>0 THEN
                lpForm1->OnMouseDown(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_RBUTTONUP
            IF lpForm1->OnMouseUp>0 THEN
                lpForm1->OnMouseUp(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_KEYDOWN
            IF lpForm1->OnKeyDown>0 THEN lpForm1->OnKeyDown(LOWORD(wParam), 0, lpForm1)

        CASE WM_KEYUP
            IF lpForm1->OnKeyUp>0 THEN lpForm1->OnKeyUp(LOWORD(wParam), 0, lpForm1)

        CASE WM_CHAR
            IF lpForm1->OnKeyPress>0 THEN lpForm1->OnKeyPress(LOBYTE(wParam), lpForm1)

        CASE WM_SYSCOMMAND
            IF (wParam AND &hfff0) = SC_CLOSE THEN
                DIM AS integer Action=1                                      ' Default Action is quit
                IF lpForm1->OnClose>0 THEN lpForm1->OnClose(Action, lpForm1) ' Action passed by reference so
                IF Action=0 THEN RETURN 0                                    ' user can change default action
            END IF

        CASE WM_ENTERSIZEMOVE
            Sizing=True

        CASE WM_EXITSIZEMOVE
            lpForm1->FormReSize()
            Sizing=False
            IF lpForm1->OnResize>0 THEN
                lpForm1->OnResize(lpForm1)
                InvalidateRect(hWnd, NULL, True)
                RETURN 0
            END IF

        CASE WM_SIZE
            IF Sizing THEN RETURN 0
            IF (wParam=SIZE_MAXIMIZED) OR (wParam=SIZE_RESTORED) THEN
                lpForm1->FormReSize()
                IF lpForm1->OnResize>0 THEN
                    lpForm1->OnResize(lpForm1)
                    RETURN 0
                END IF
            END IF

        CASE WM_CLOSE

        CASE WM_DESTROY
            KillAllTimers()
            PostQuitMessage(0)

    END SELECT

    RETURN DefWindowProc(hWnd, wMsg, wParam, lParam)
END FUNCTION

'-------------------------------------------------------------------------------
' Create new window class for project
'-------------------------------------------------------------------------------
FUNCTION CreateWindClass(hInst AS HINSTANCE) AS integer
DIM AS integer Result
DIM AS WNDCLASSEX wc

WITH wc
    .cbSize = SizeOf(WNDCLASSEX)
    .style = CS_HREDRAW OR CS_VREDRAW
    .lpfnWndProc = @MainWndProc
    .hInstance = hInst
    .hIcon = LoadIcon(0, IDI_APPLICATION)
    .hCursor = LoadCursor(0, IDC_ARROW)
    .hbrBackground = GetSysColorBrush(COLOR_BTNFACE)
    .lpszClassName = @"RQClass"
    .hIconSm = .hIcon
END WITH

    Result = RegisterClassEx(@wc)
    IF Result = 0 THEN ShowMessage("Register class error")
    RETURN Result
END FUNCTION

'-------------------------------------------------------------------------------
' Main startup code
'-------------------------------------------------------------------------------
FUNCTION WinMain(hInst AS HINSTANCE, hPrevInstance AS HINSTANCE, _
                            szCmdLine AS string, iCmdShow AS integer) AS integer
DIM AS integer Result=0

    IF CreateWindClass(hInst) = 0 THEN RETURN 0

    ConfigureComponents()
    CreateComponents()
    InitSystemTimers(lpForm1->Handle)
    HookTheMouse()

    lpForm1->Center                         ' You may wish to delete this line

    IF lpForm1->OnShow>0 THEN lpForm1->OnShow(lpForm1)

    Result = lpForm1->ShowModal             ' Show form & call default message handler

    ' You may want to change the above line to lpForm1->Show, and then provide
    ' your own function that, amongst other things, handles all window messages.

    UnHookTheMouse()

    RETURN Result
END FUNCTION

'-------------------------------------------------------------------------------
' *** MAIN ENTRY POINT ***
'-------------------------------------------------------------------------------
END WinMain(Application.hInstance, NULL, Command(0), SW_NORMAL)


'-------------------------------------------------------------------------------
' Code for the component events
'-------------------------------------------------------------------------------
SUB PaintShape(Sender AS QFORM)
DIM AS PAINTSTRUCT pnt
DIM AS HDC memDC, hDC
DIM AS RECT rct

    hDC=BeginPaint(Sender.Handle, @pnt)
    GetClientRect(Sender.Handle, @rct)
    memDC=CreateCompatibleDC(hDC)
    SelectObject(memDC, hBmp)
    BitBlt(hDC, rct.Left, rct.Top, rct.Right-rct.Left, rct.Bottom-rct.Top, memDC, rct.Left, rct.Top, SRCCOPY)
    EndPaint(Sender.Handle, @pnt)
END SUB

' This does all the work! The bigger the bmp the longer it will take to render the region!!
FUNCTION CreateBmpRegion(W AS integer, H AS integer) AS HRGN
DIM AS integer x, y
DIM AS integer TranspColor, InTransparent, xStart
DIM AS HRGN hRgnTemp, hRgnOut
DIM AS HDC ScrnDC, memDC

    ScrnDC=GetDC(NULL)
    memDC=CreateCompatibleDC(ScrnDC)
    SelectObject(memDC, hBmp)
    TranspColor=GetPixel(memDC, 0, 0)                               ' Pixel (0,0) used for transparency
    hRgnOut=CreateRectRgn(0,0,1,1)                                  ' An initial region MUST exist
    FOR y=0 TO H-1
        hRgnTemp=CreateRectRgn(0,y,W,y+1)
        CombineRgn(hRgnOut, hRgnOut, hRgnTemp, RGN_XOR)             ' Add FULL line of bmp to region...
        FOR x=0 TO W-1                                              ' ...then remove transparent bits
            IF GetPixel(memDC, x, y)=TranspColor THEN
                IF InTransparent=False THEN
                    InTransparent=True
                    xStart=x
                END IF
            ELSE
                IF InTransparent=True THEN                          ' Remove the transparent section
                    hRgnTemp=CreateRectRgn(xStart,y,x,y+1)
                    CombineRgn(hRgnOut, hRgnOut, hRgnTemp, RGN_XOR)
                    DeleteObject(hRgnTemp)
                    InTransparent=False
                END IF
            END IF
        NEXT x
        IF InTransparent THEN                                       ' To the end of the line?
            hRgnTemp = CreateRectRgn(xStart,y,x,y+1)
            CombineRgn(hRgnOut, hRgnOut, hRgnTemp, RGN_XOR)
            DeleteObject(hRgnTemp)
            InTransparent=False
        END IF
    NEXT y
    DeleteObject(memDC)
    ReleaseDC(NULL, ScrnDC)
    RETURN hRgnOut
END FUNCTION

SUB ShapeForm(Sender AS QFORM)
DIM AS MSG wMsg
DIM AS BITMAP BMap
DIM AS HRGN hRegion

    IF FileExists(SPLASH)=False THEN
        ShowMessage(SPLASH+" does not exist .. exiting!")
        Application.Terminate
    END IF

    hBmp=LoadImage(NULL, SPLASH, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE)
    GetObject(hBmp, SIZEOF(BITMAP), @BMap)      ' Get INFO (ONLY) about image object
    hRegion=CreateBmpRegion(BMap.bmWidth, BMap.bmHeight)

    Sender.Width=BMap.bmWidth: Sender.Height=BMap.bmHeight
    Sender.Left=(Screen.Width-BMap.bmWidth)\2
    Sender.Top=(Screen.Height-BMap.bmHeight)\2
    SetWindowRgn(Sender.Handle, hRegion, TRUE)
    lpTimer1->Tag=0
    lpTimer1->Enabled = True

    ShowWindow(Sender.Handle, SW_NORMAL)
    UpdateWindow(Sender.Handle)
    WHILE GetMessage(@wMsg, NULL, 0, 0) <> FALSE
        TranslateMessage(@wMsg)
        DispatchMessage(@wMsg)
        IF lpTimer1->Tag>0 THEN EXIT WHILE
    WEND
    Application.Terminate
END SUB

SUB DoTimer(Sender AS QTIMER)
    Sender.Tag=1                    ' Signal we are finished
END SUB

